import os
import subprocess
import itertools

runtest = ["liblr-ori", "passcode-exp-0.1", "liblinear-eps5"]
coretest = {"liblr-ori": [1], "passcode-exp-0.1": [1, 2, 4, 8], "liblinear-eps5": [1, 2, 4, 8]}
dicC = [1]
dicE = [0.005]
dicR = {"liblr-ori": "ori", "passcode-exp-0.1": "pass", "liblinear-eps5": "eps5new"}
dataset = ["heart_scale"]

ROOT_PATH="../"
DATA_PATH="/mnt/disk0/binary/"
LOG_PATH=ROOT_PATH+"log/"
MOD_PATH=ROOT_PATH+"model/"
train="/train"

LOSS = 3

for data in dataset:
    print("Running "+data)
    for run in runtest:
        if len(coretest[run]) == 0:
            continue
        print("Using "+run)
        comb = list(itertools.product(dicE, dicC, coretest[run]))
        for e, C, core in comb:
            filename = "%s%s.%s.n%d.c%g.e%g.log" % (LOG_PATH, data, dicR[run], core, C, e)
            logfile = open(filename, "w+")
            logfile.write("*************************\n")
            logfile.write("Using "+run+"\n")
            print("running with "+str(core)+" cores, C = "+str(C)+" e = "+str(e))
            if run == "liblr-ori":
                comd = "%s%s%s -s %d -c %f -e %f %s%s %s%s-%s.model" % (ROOT_PATH, run, train, LOSS, C, e, DATA_PATH, data, MOD_PATH, data, run)
                print(comd)
            elif run == "passcode-exp-0.1":
                comd = "%s%s%s-shrinking -t 500 -s 5%d -c %f -e %f -n %d -b 0 %s%s %s%s" % (ROOT_PATH, run, train, LOSS, C, e, core, DATA_PATH, data, DATA_PATH, data)
                print(comd)
            elif run == "liblinear-eps5":
                comd = "%s%s%s -s %d -c %f -e 0.000001 -Q 256 -n %d %s%s %s%s-%s.model" % (ROOT_PATH, run, train, LOSS, C, core, DATA_PATH, data, MOD_PATH, data, run)
                print(comd)
            else:
                print("Method Not Found.")
                exit()
            print(comd.split(' '))
            p = subprocess.Popen(comd.split(' '), stdout=subprocess.PIPE)
            logfile.write("-------------------------\n")
            logfile.write("Running "+data+"\n")
            logfile.write("-------------------------\n")
            logfile.write("running with "+str(core)+" cores, C = "+str(C)+" e = "+str(e)+"\n")
            out, err = p.communicate()
            #print(out)
            logfile.write(out)
